package com.ejie.ab79.service.expedientes;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab79.clientesWS.ab61WebService.Usuario;
import com.ejie.ab79.dao.RelEstInsDao;
import com.ejie.ab79.dao.expedientes.DatosTercerosDao;
import com.ejie.ab79.dao.expedientes.RelExpTerDao;
import com.ejie.ab79.model.RelEstIns;
import com.ejie.ab79.model.REST.servicioWeb.Interesado;
import com.ejie.ab79.model.expedientes.DatosTerceros;
import com.ejie.ab79.model.expedientes.RelExpTer;
import com.ejie.ab79.model.inspecciones.Inspecciones;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * DatosTercerosServiceImpl  
 * 
 *  
 */

@Service(value = "datosTercerosService")
public class DatosTercerosServiceImpl implements DatosTercerosService {

	@Autowired
	private DatosTercerosDao datosTercerosDao;

	@Autowired
	private RelEstInsDao relEstInsDao;

	@Autowired
	private RelExpTerDao relExpTerDao;

	/**
	 * Inserts a single row in the DatosTerceros table.
	 *
	 * @param datosTerceros
	 *            DatosTerceros
	 * @return DatosTerceros
	 */
	@Override
	@Transactional(rollbackFor = Throwable.class)
	public DatosTerceros add(DatosTerceros datosTerceros) {
		return this.datosTercerosDao.add(datosTerceros);
	}

	/**
	 * Finds el ultimo id de la tabla in the DatosTerceros table.
	 *
	 * 
	 * @return datosTerceros Datosterceros
	 */
	@Override
	public DatosTerceros findUltimoId() {
		return this.datosTercerosDao.findUltimoId();
	}

	/**
	 * Updates a single row in the DatosTerceros table.
	 *
	 * @param datosTerceros
	 *            DatosTerceros
	 * @return DatosTerceros
	 */
	@Override
	@Transactional(rollbackFor = Throwable.class)
	public DatosTerceros update(DatosTerceros datosTerceros) {
		if (0 == datosTerceros.getSexo().getIdSexo()) {
			datosTerceros.setSexo(null);
		}
		return this.datosTercerosDao.update(datosTerceros);
	}

	/**
	 * Finds a single row in the DatosTerceros table.
	 *
	 * @param datosterceros
	 *            DatosTerceros
	 * @return DatosTerceros
	 */

	@Override
	public DatosTerceros find(DatosTerceros datosTercero) {
		return this.datosTercerosDao.find(datosTercero);
	}

	/**
	 * Finds a single row in the DatosTerceros table.
	 *
	 * @param datosterceros
	 *            DatosTerceros
	 * @return DatosTerceros
	 */

	@Override
	public DatosTerceros findTercero(Integer idTercero, String partipantId) {
		return this.datosTercerosDao.findTercero(idTercero, partipantId);
	}

	/**
	 * Encuentra los datos de tercero tipo : persona de contacto o responsable
	 * legal
	 *
	 * @param datosterceros
	 *            DatosTerceros
	 * @return DatosTerceros
	 */

	@Override
	public DatosTerceros findPersonacontactoResponsableLegal(Integer idTercero, Long tipo, Integer idExpediente) {
		return this.datosTercerosDao.findPersonacontactoResponsableLegal(idTercero, tipo, idExpediente);
	}

	/**
	 * Deletes a single row in the DatosTercero.
	 *
	 * @param datosTerceros
	 *            DatosTerceros
	 * @param idExpediente
	 *            Integer
	 **/
	@Override
	public void removeIdTercero(DatosTerceros datosTerceros) {

		// this.relExpTerDao.removeidTercero(datosTerceros.getIdTercero());
		this.datosTercerosDao.remove(datosTerceros.getIdTercero());

	}

	/**
	 * Finds a list of rows in the DatosTerceros table.
	 *
	 * @param datosTerceros
	 *            DatosTerceros
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<DatosTerceros>
	 */
	@Override
	public List<DatosTerceros> findAll(DatosTerceros datosTerceros, JQGridRequestDto jqGridRequestDto) {
		return this.datosTercerosDao.findAll(datosTerceros, jqGridRequestDto);
	}

	/**
	 * Finds rows in the DatosTerceros table using like.
	 *
	 * @param datosTerceros
	 *            DatosTerceros
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<DatosTerceros>
	 */
	@Override
	public List<DatosTerceros> findAllLike(DatosTerceros datosTerceros, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return this.datosTercerosDao.findAllLike(datosTerceros, jqGridRequestDto, startsWith);
	}

	@Override
	public List<Interesado> findInteresadosREST(Integer idExpediente, Integer idInspeccion) {
		return this.datosTercerosDao.findInteresadosREST(idExpediente, idInspeccion);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the DatosTerceros table.
	 *
	 * @param filterDatosTerceros
	 *            DatosTerceros
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	@Override
	public void removeMultiple(DatosTerceros filterDatosTerceros, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		this.datosTercerosDao.removeMultiple(filterDatosTerceros, jqGridRequestDto, startsWith);
	}

	/**
	 * Filter method in the DatosTerceros table.
	 *
	 * @param filterDatosTerceros
	 *            DatosTerceros
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<DatosTerceros>
	 */
	@Override
	public JQGridResponseDto<DatosTerceros> filter(DatosTerceros filterDatosTerceros, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		List<DatosTerceros> listaDatosTerceros = this.datosTercerosDao.findAllLike(filterDatosTerceros,
				jqGridRequestDto, false);
		Long recordNum = this.datosTercerosDao
				.findAllLikeCount(filterDatosTerceros != null ? filterDatosTerceros : new DatosTerceros(), false);
		if (jqGridRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<DatosTerceros>> reorderSelection = this.datosTercerosDao
					.reorderSelection(filterDatosTerceros, jqGridRequestDto, startsWith);
			return new JQGridResponseDto<DatosTerceros>(jqGridRequestDto, recordNum, listaDatosTerceros,
					reorderSelection);
		}
		return new JQGridResponseDto<DatosTerceros>(jqGridRequestDto, recordNum, listaDatosTerceros);
	}

	/**
	 * Searches rows in the DatosTerceros table.
	 *
	 * @param filterDatosTerceros
	 *            DatosTerceros
	 * @param searchDatosTerceros
	 *            DatosTerceros
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<DatosTerceros>>
	 */
	@Override
	public List<TableRowDto<DatosTerceros>> search(DatosTerceros filterDatosTerceros, DatosTerceros searchDatosTerceros,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		return this.datosTercerosDao.search(filterDatosTerceros, searchDatosTerceros, jqGridRequestDto, startsWith);
	}

	/**
	 * Reorder the selection made in DatosTerceros table.
	 *
	 * @param filterDatosTerceros
	 *            DatosTerceros
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	@Override
	public Object reorderSelection(DatosTerceros filterDatosTerceros, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		return this.datosTercerosDao.reorderSelection(filterDatosTerceros, jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the DatosTerceros table.
	 *
	 * @param filterDatosTerceros
	 *            DatosTerceros
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<DatosTerceros>>
	 */
	public JQGridResponseDto<JerarquiaDto<DatosTerceros>> jerarquia(DatosTerceros filterDatosTerceros,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<JerarquiaDto<DatosTerceros>> listaDatosTerceros = this.datosTercerosDao
				.findAllLikeJerarquia(filterDatosTerceros, jqGridRequestDto);
		Long recordNum = this.datosTercerosDao.findAllLikeCountJerarquia(filterDatosTerceros, jqGridRequestDto);
		return new JQGridResponseDto<JerarquiaDto<DatosTerceros>>(jqGridRequestDto, recordNum, listaDatosTerceros);
	}

	/**
	 * Finder method for siblings rows in the hierarchical the DatosTerceros
	 * table.
	 *
	 * @param filterDatosTerceros
	 *            DatosTerceros
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<DatosTerceros>>
	 */
	public JQGridResponseDto<JerarquiaDto<DatosTerceros>> jerarquiaChildren(DatosTerceros filterDatosTerceros,
			JQGridRequestDto jqGridRequestDto) {
		JQGridResponseDto<JerarquiaDto<DatosTerceros>> jqGridResponseDto = new JQGridResponseDto<JerarquiaDto<DatosTerceros>>();
		jqGridResponseDto.addAdditionalParam(JQGridResponseDto.CHILDREN,
				this.datosTercerosDao.findAllChild(filterDatosTerceros, jqGridRequestDto));
		return jqGridResponseDto;
	}

	@Override
	public List<DatosTerceros> findDenunciadoByExpediente(Integer idExpediente) {
		return this.datosTercerosDao.findDenunciadoByExpediente(idExpediente);
	}

	@Override
	public List<DatosTerceros> findTitularExpediente(Integer idExpediente) {
		return this.datosTercerosDao.findTitularExpediente(idExpediente);
	}

	@Transactional
	@Override
	public DatosTerceros buscarTercero(String numeroRegistro, Integer idInspeccion, Usuario usuario) throws Exception {

		List<DatosTerceros> listaTerceros = this.datosTercerosDao.buscarTercero(numeroRegistro);

		if (listaTerceros.size() == 1) {
			DatosTerceros tercero = listaTerceros.get(0);
			DatosTerceros terceroAux;
			if (tercero.getTipoDocumento().getIdTipoDocumento() != 0) {

				RelEstIns relEstIns = this.relEstInsDao.findByInspeccion(new Inspecciones(idInspeccion));

				if (relEstIns != null && relEstIns.getIdTercero() != null) {
					// UPDATE AB6135T00
					tercero.setIdTercero(relEstIns.getIdTercero());
					tercero.setUsuarioUltmodificacion(usuario.getUsuario());
					terceroAux = this.datosTercerosDao.update(tercero);

				} else {
					// INSERT AB6135T00
					tercero.setUsuarioRegistro(usuario.getUsuario());
					terceroAux = this.datosTercerosDao.add(tercero);

					// UPDATE AB7922T00
					if (relEstIns == null) {
						relEstIns = new RelEstIns();
					}
					relEstIns.setIdTercero(terceroAux.getIdTercero());
					relEstIns.setUsuarioUltModificacion(usuario.getUsuario());
					this.relEstInsDao.update(relEstIns);
				}
			} else {
				throw new Exception();
			}

			return terceroAux;
		} else {
			return null;
		}

	}

	@Override
	public void addTerceroConRelacion(RelExpTer relExpTer) {
		DatosTerceros datosTercerosAux = this.datosTercerosDao.add(relExpTer.getDatosTerceros());
		relExpTer.getDatosTerceros().setIdTercero(datosTercerosAux.getIdTercero());

		this.relExpTerDao.add(relExpTer);
	}

	@Override
	public DatosTerceros findTitularActividad(String identificadorEstablecimiento) {
		return this.datosTercerosDao.findTitularActividad(identificadorEstablecimiento);
	}

	@Override
	public DatosTerceros findParteInculpadaByIdExpediente(Integer idExpediente) {
		return this.datosTercerosDao.findParteInculpadaByIdExpediente(idExpediente);
	}

}
